/*
   95Reader ext library
   
   by Noritsugu Nakamura
   from 1999.06.26

   95Reader http://www.ssct.co.jp/95reader/
*/

# include <windows.h>
# include <PF_Def.h>
# include <SOUNDMSG.H>

#include "ruby.h"

static VALUE mReader;

static VALUE
rb_ext_reader_message(obj, str, flags)
	 VALUE obj, str, flags;
{
  return INT2NUM(SoundMessage(STR2CSTR(str), NUM2INT(flags)));
}

static VALUE
rb_ext_reader_pause(obj, onoff)
	 VALUE obj, onoff;
{
  int retval;

  retval = SoundPause(NUM2INT(onoff));
  if(retval == 0) {
	return 0;
  } else if(retval == -1) {
	rb_raise(rb_eRuntimeError, "SoundPause: R95_ERR\n");
  } else if(retval == -2) {
	rb_raise(rb_eRuntimeError, "SoundPause: R95_STATUS\n");
  }
}

static VALUE
rb_ext_reader_status(obj)
	 VALUE obj;
{
  return INT2NUM(SoundStatus());
}

static VALUE
rb_ext_reader_modifymode(obj, on, off)
	 VALUE obj, on, off;
{
  return INT2NUM(SoundModifyMode(NUM2INT(on), NUM2INT(off)));
}

void
Init_reader()
{
    mReader = rb_define_module("Reader");
    rb_define_module_function(mReader, "message", rb_ext_reader_message, 2);
    rb_define_module_function(mReader, "pause", rb_ext_reader_pause, 1);
    rb_define_module_function(mReader, "status", rb_ext_reader_status, 0);
    rb_define_module_function(mReader, "modifymode", rb_ext_reader_modifymode, 2);

    rb_define_const(mReader, "SW_DEFAULT", INT2FIX(R95_SW_DEFAULT));
    rb_define_const(mReader, "SW_SOUND", INT2FIX(R95_SW_SOUND));
    rb_define_const(mReader, "SW_KEYECHO", INT2FIX(R95_SW_KEYECHO));
    rb_define_const(mReader, "SW_KEYECHO2", INT2FIX(R95_SW_KEYECHO2));
    rb_define_const(mReader, "SW_CLIPBOARD", INT2FIX(R95_SW_CLIPBOARD));
    rb_define_const(mReader, "SW_MOUSE", INT2FIX(R95_SW_MOUSE));
    rb_define_const(mReader, "SW_MENU", INT2FIX(R95_SW_MENU));
    rb_define_const(mReader, "SW_STARTMENU", INT2FIX(R95_SW_STARTMENU));
    rb_define_const(mReader, "SW_IME", INT2FIX(R95_SW_IME));
    rb_define_const(mReader, "SW_EXCEL", INT2FIX(R95_SW_EXCEL));
    rb_define_const(mReader, "SW_AUXINPUT", INT2FIX(R95_SW_AUXINPUT));
    rb_define_const(mReader, "SW_ACCESSKEY", INT2FIX(R95_SW_ACCESSKEY));
    rb_define_const(mReader, "SW_HOTKEY", INT2FIX(R95_SW_HOTKEY));
    rb_define_const(mReader, "SW_STEREO", INT2FIX(R95_SW_STEREO));
    rb_define_const(mReader, "SW_16BIT", INT2FIX(R95_SW_16BIT));

    rb_define_const(mReader, "PF_DONT_IGNORE", INT2FIX(PF_DONT_IGNORE));
    rb_define_const(mReader, "PF_DETAIL", INT2FIX(PF_DETAIL));
    rb_define_const(mReader, "PF_CURSOR_MOVE", INT2FIX(PF_CURSOR_MOVE));
    rb_define_const(mReader, "PF_IME_CHANGE", INT2FIX(PF_IME_CHANGE));
    rb_define_const(mReader, "PF_TONE_DOWN", INT2FIX(PF_TONE_DOWN));
    rb_define_const(mReader, "PF_NATURAL_PROOF", INT2FIX(PF_NATURAL_PROOF));
    rb_define_const(mReader, "PF_ABSOLUTE_OUT", INT2FIX(PF_ABSOLUTE_OUT));
    rb_define_const(mReader, "PF_KEY_ECHO", INT2FIX(PF_TONE_UP));
    rb_define_const(mReader, "PF_FORMAT", INT2FIX(PF_FORMAT));
}
